#ifndef _AVATAR_H_
#define _AVATAR_H_

// trieda premennych a funkcii (objektov) pre pracu s Avatarom
class CAvatar {
public:
 CAvatar();  // konstruktor
 ~CAvatar(); // destruktor

 // vyska oci Avatara
 GLfloat avatarEye;
 // polovica sirky Avatara
 GLfloat avatarWidth;
 // sklon roviny, ktory dokaze Avatar prekonat
 GLfloat avatarSlope;

 vec3 actpos; // aktualna poloha Avatara

 // indikatory pre vykonavanie definovanych posunov Avatara
 GLfloat goForward,goBack,goUp,goDown,goRight,goLeft;
 GLfloat goLeanLeft,goLeanRight;
 GLfloat goJump,goFast;
 GLubyte isFire1; // strelba1 (lave tlacidlo mysi)
 GLubyte isFire2; // strelba2 (prave tlacidlo mysi)

 // inicializacia Avatara
 void init(void);
 // reset parametrov Avatara
 void reset(void);
 // nastavenie prirastkov pre zmenu polohy Avatara
 void setmovxyz(GLfloat DT);
 // nastavenie prirastkov pre zmenu natocenia Avatara
 void setrotxy(GLfloat X,GLfloat Y);
 void setrotzl(GLfloat Z);
 void setrotzr(GLfloat Z);
 // aktualizacia parametrov Avatara
 void update(GLfloat DT);
private:
 GLubyte movetype; // typ pohybu

 mat16 mat; // transformacna matica Avatara, hodnoty prvkov hlavnej diagonaly
            // sa automaticky nastavia na 1.0f (v math3d.h)

 vec3 oldpos,move,oldmove; // povodna poloha Avatara, prirastok pre zmenu polohy
 vec3 angle,rotate;        // natocenie, prirastok pre zmenu natocenia
 vec3 target;              // vektor smerujuci dopredu

 // kracanie Avatara
 GLfloat tilt,tiltAbs;
 bool goTilt;
 // uklon Avatara od zvislej roviny
 GLfloat lean,leanAdd;

 GLfloat canRotate; // indikator dokoncenia rotacie

 // koeficienty
 GLfloat speed,slide,altit;    // rychlost, bocny pohyb, zmena vysky
 GLfloat gravity;              // gravitacne zrychlenie
 GLfloat viewnear,viewfar;     // minimalny a maximalny dohlad
 GLfloat fov;                  // zorny uhol pohladu
 GLuint jumpSpeed;             // rychlost skoku
 GLfloat jumpTime;             // cas zacatia skoku

 GLfloat accelX,accelZ; // akceleracia Avatara
 GLfloat accelAddX,accelAddZ;

 GLfloat rightLeft,forwardBack; // tlacidla vlavo/vpravo, dopredu/dozadu

 GLfloat gravityTime;     // aktualny cas posobenia gravitacie
 GLfloat gT;              // prirastok casu pri skoku/posobeni gravitacie - zavisly na FPS
 GLfloat gKoef[MAXFPS+1]; // prirastky casu pre skok/pad - zavisle na FPS

 GLfloat d1,d2,d3; // pomocne premenne
 vec3 p,q;         // pomocne vektory

 vec3 Apos,Opos; // pomocne vektory pre docasne ulozenie poloh Avatara

 GLuint testNum; // pocet trojuholnikov, s ktorymi sa testuje kolizia
 // indikatory detekovanych kolizii
 bool isWallCollision,isUpDownCollision;

 // detekcia kolizie Avatara s objektami (trojuholnikmi)
 void detectCollision(void);
};

#endif
